package ru.dbotthepony.mc.otm.menu.data;

import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.world.inventory.ClickAction;
import net.minecraft.world.inventory.ClickType;
import net.minecraftforge.network.NetworkEvent;

import java.util.function.Supplier;

public record InteractPacket(int id, int stack_id, ClickType click, ClickAction action) {
	public void write(FriendlyByteBuf buffer) {
		buffer.writeInt(id);
		buffer.writeInt(stack_id);
		buffer.writeEnum(click);
		buffer.writeEnum(action);
	}

	public static InteractPacket read(FriendlyByteBuf buffer) {
		var id = buffer.readInt();
		var stack = buffer.readInt();
		var click = buffer.readEnum(ClickType.class);
		var action = buffer.readEnum(ClickAction.class);
		return new InteractPacket(id, stack, click, action);
	}

	public void play(Supplier<NetworkEvent.Context> context) {
		context.get().setPacketHandled(true);
		context.get().enqueueWork(() -> {
			var ply = context.get().getSender();

			if (ply.containerMenu instanceof INetworkedItemViewSupplier supplier && ply.containerMenu.containerId == id) {
				ply.resetLastActionTime();
				supplier.getNetworkedItemView().playerInteract(this);
			}
		});
	}
}
