package ru.dbotthepony.mc.otm.graph.storage

import net.minecraft.MethodsReturnNonnullByDefault
import ru.dbotthepony.mc.otm.graph.Graph6Node
import ru.dbotthepony.mc.otm.storage.IStorageIdentity
import javax.annotation.ParametersAreNonnullByDefault

@MethodsReturnNonnullByDefault
@ParametersAreNonnullByDefault
interface IStorageGraphNode {
	/**
	 * Return all providers that this cell can store. Or nothing, if it is not a storage.
	 *
	 * If you don't know what you are going to store, you may return nothing.
	 *
	 * If something pops up, call [getStorageGraph], and then, call [StorageNetworkGraph.add].
	 */
	fun getComponents(): Collection<IStorageIdentity<*>>

	fun getAsStorageNode(): Graph6Node<IStorageGraphNode>
	fun getStorageGraph(): StorageNetworkGraph? = getAsStorageNode().graph as StorageNetworkGraph?
}
