package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.SimpleContainer
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.Registry
import ru.dbotthepony.mc.otm.block.entity.BlockEntityDriveRack

class DriveRackMenu @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory,
	tile: BlockEntityDriveRack? = null
) : PoweredMatteryMenu(Registry.Menus.DRIVE_RACK, p_38852_, inventory, tile) {
	val drives = arrayOfNulls<MatterySlot>(4)

	init {
		val container = tile?.drives ?: SimpleContainer(4)

		for (i in 0 until container.containerSize) {
			val slot = DriveSlot(container, i)
			drives[i] = slot
			addSlot(slot)
		}

		addInventorySlots()
	}

	override fun getWorkingSlotStart(): Int {
		return 0
	}

	override fun getWorkingSlotEnd(): Int {
		return 5
	}
}